/* Original code from Mike Godwin at
http://www.mat.ucsb.edu/~g.legrady/academic/courses/06w259/projs/mg/KohonenSpectrum/
Adapted by Kitty Currier, 2/2014 */

import java.util.*;  //code doesn't run on some setups without this

KohonenSet klist = new KohonenSet();
Table dataTable;
int dataRowsLoaded; // number of rows loaded (not including 1 header row)
float dataList[][];
int screenW = 600;
int screenH = 360;
PFont font12;
PFont font24;
int inputDims = 5; // input data dimensionality
int kMapH = 60;  // map height
int kMapW = 60;  //map width

void setup(){
  
  size(screenW, screenH+120);
  font12 = createFont("Arial", 12, true);
  font24 = createFont("Arial", 24, true);
  dataTable = new Table("testTable100.csv");  //read data from CSV
  createDataList();  //read data from dataTable into dataList
  klist.kset = dataList;
  
  klist.initWeights(kMapH, kMapW, inputDims);  //SOM dimensions #nodes (h) x #nodes (w)
  ellipseMode(CENTER);  
}

void draw(){
  colorMode(HSB, 359, 99, 99);
  background(0, 99, 0);
  if(klist.mapMode == 0) klist.map();
  if(klist.mapMode == 1) klist.errorMap();
  klist.legend();
  klist.bmuLabels();
  klist.train(); 

}

void createDataList(){
  dataList = new float[dataTable.getRowCount()][inputDims];  
  for (int i=1; i<dataTable.getRowCount(); i++){  //start on second row, past headers
    dataRowsLoaded++;
    for (int j=0; j<inputDims; j++){
      dataList[i][j] = dataTable.getFloat(i,j);
    }
  }
  println("data rows loaded: "+dataRowsLoaded);
}

void keyReleased(){
  if (key == '=') klist.mapMode = 0;
  if (key == '-') klist.mapMode = 1;
}
